## juju-mongodb2.6 2.6.10

=== SConstruct ===
# -*- mode: python; -*-
# build file for MongoDB
# this requires scons
# you can get from http://www.scons.org
# then just type scons

# some common tasks
#   build 64-bit mac and pushing to s3
#      scons --64 s3dist
#      scons --distname=0.8 s3dist
#      all s3 pushes require settings.py and simples3

# This file, SConstruct, configures the build environment, and then delegates to
# several, subordinate SConscript files, which describe specific build rules.

import buildscripts
import copy
import datetime
import imp
import os
import re
import shutil
import stat
import sys
import textwrap
import types
import urllib
import urllib2
from buildscripts import utils
from buildscripts import moduleconfig

import libdeps

EnsureSConsVersion( 1, 1, 0 )
if "uname" in dir(os):
    scons_data_dir = ".scons/%s/%s" % ( os.uname()[0] , os.getenv( "HOST" , "nohost" ) )
else:
    scons_data_dir = ".scons/%s/" % os.getenv( "HOST" , "nohost" )
SConsignFile( scons_data_dir + "/sconsign" )

DEFAULT_INSTALL_DIR = "/usr/local"


def findSettingsSetup():
    sys.path.append( "." )
    sys.path.append( ".." )
    sys.path.append( "../../" )

def versiontuple(v):
    return tuple(map(int, (v.split("."))))

# --- platform identification ---
#
# This needs to precede the options section so that we can only offer some options on certain
# platforms.

platform = os.sys.platform
nix = False
linux = False
darwin = False
windows = False
freebsd = False
openbsd = False
solaris = False

if "darwin" == platform:
    darwin = True
    platform = "osx" # prettier than darwin
elif platform.startswith("linux"):
    linux = True
    platform = "linux"
elif "sunos5" == platform:
    solaris = True
elif platform.startswith( "freebsd" ):
    freebsd = True
elif platform.startswith( "openbsd" ):
    openbsd = True
elif "win32" == platform:
    windows = True
else:
    print( "No special config for [" + platform + "] which probably means it won't work" )

nix = not windows

# --- options ----
use_clang = False

options = {}

def add_option( name, help, nargs, contributesToVariantDir,
                dest=None, default = None, type="string", choices=None, metavar=None ):

    if dest is None:
        dest = name

    if type == 'choice' and not metavar:
        metavar = '[' + '|'.join(choices) + ']'

    AddOption( "--" + name ,
               dest=dest,
               type=type,
               nargs=nargs,
               action="store",
               choices=choices,
               default=default,
               metavar=metavar,
               help=help )

    options[name] = { "help" : help ,
                      "nargs" : nargs ,
                      "contributesToVariantDir" : contributesToVariantDir ,
                      "dest" : dest,
                      "default": default }

def get_option( name ):
    return GetOption( name )

def has_option( name ):
    x = get_option( name )
    if x is None:
        return False

    if x == False:
        return False

    if x == "":
        return False

    return True

def use_system_version_of_library(name):
    return has_option('use-system-all') or has_option('use-system-' + name)

def get_variant_dir():
    if has_option('variant-dir'):
        return "#build/" + get_option('variant-dir')

    substitute = lambda x: re.sub( "[:,\\\\/]" , "_" , x )

    a = []

    for name in options:
        o = options[name]
        if not has_option( o["dest"] ):
            continue
        if not o["contributesToVariantDir"]:
            continue
        if get_option(o["dest"]) == o["default"]:
            continue

        if o["nargs"] == 0:
            a.append( name )
        else:
            x = substitute( get_option( name ) )
            a.append( name + "_" + x )

    extras = []
    if has_option("extra-variant-dirs"):
        extras = [substitute(x) for x in get_option( 'extra-variant-dirs' ).split( ',' )]

    if has_option("add-branch-to-variant-dir"):
        extras += ["branch_" + substitute( utils.getGitBranch() )]

    if has_option('cache'):
        s = "#build/cached/"
        s += "/".join(extras) + "/"
    else:
        s = "#build/${PYSYSPLATFORM}/"
        a += extras

        if len(a) > 0:
            a.sort()
            s += "/".join( a ) + "/"
        else:
            s += "normal/"

    return s

# build output
add_option( "mute" , "do not display commandlines for compiling and linking, to reduce screen noise", 0, False )

# installation/packaging
add_option( "prefix" , "installation prefix" , 1 , False, default=DEFAULT_INSTALL_DIR )
add_option( "distname" , "dist name (0.8.0)" , 1 , False )
add_option( "distmod", "additional piece for full dist name" , 1 , False )
add_option( "nostrip", "do not strip installed binaries" , 0 , False )
add_option( "extra-variant-dirs", "extra variant dir components, separated by commas", 1, False)
add_option( "add-branch-to-variant-dir", "add current git branch to the variant dir", 0, False )
add_option( "variant-dir", "override variant subdirectory", 1, False )

add_option( "sharedclient", "build a libmongoclient.so/.dll [DEPRECATED/IGNORED]" , 0 , False )
add_option( "full", "include client and headers when doing scons install [DEPRECATED/IGNORED]", 0 , False )

# linking options
add_option( "release" , "release build" , 0 , True )
add_option( "static" , "fully static build" , 0 , False )
add_option( "static-libstdc++" , "statically link libstdc++" , 0 , False )
add_option( "lto", "enable link time optimizations (experimental, except with MSVC)" , 0 , True )
add_option( "dynamic-windows", "dynamically link on Windows", 0, True)
add_option( "disable-declspec-thread", "don't use __declspec(thread) on Windows [DEPRECATED/IGNORED]", 0, True)

# base compile flags
add_option( "64" , "whether to force 64 bit" , 0 , True , "force64" )
add_option( "32" , "whether to force 32 bit" , 0 , True , "force32" )

add_option( "cxx", "compiler to use" , 1 , True )
add_option( "cc", "compiler to use for c" , 1 , True )
add_option( "cc-use-shell-environment", "use $CC from shell for C compiler" , 0 , False )
add_option( "cxx-use-shell-environment", "use $CXX from shell for C++ compiler" , 0 , False )
add_option( "ld", "linker to use" , 1 , True )
add_option( "c++11", "enable c++11 support (experimental)", 0, True )

add_option( "cpppath", "Include path if you have headers in a nonstandard directory" , 1 , False )
add_option( "libpath", "Library path if you have libraries in a nonstandard directory" , 1 , False )

add_option( "extrapath", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) static linking" , 1 , False )
add_option( "extrapathdyn", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) dynamic linking" , 1 , False )
add_option( "extralib", "comma separated list of libraries  (--extralib js_static,readline" , 1 , False )

add_option( "no-glibc-check" , "don't check for new versions of glibc" , 0 , False )

# experimental features
add_option( "mm", "use main memory instead of memory mapped files" , 0 , True )
add_option( "asio" , "Use Asynchronous IO (NOT READY YET)" , 0 , True )
add_option( "ssl" , "Enable SSL" , 0 , True )
add_option( "ssl-fips-capability", "Enable the ability to activate FIPS 140-2 mode", 0, True );

# library choices
add_option( "usev8" , "use v8 for javascript" , 0 , True )
add_option( "libc++", "use libc++ (experimental, requires clang)", 0, True )

# mongo feature options
add_option( "noshell", "don't build shell" , 0 , True )
add_option( "safeshell", "don't let shell scripts run programs (still, don't run untrusted scripts)" , 0 , True )
add_option( "win2008plus",
            "use newer operating system API features (deprecated, use win-version-min instead)" ,
            0 , False )

# dev options
add_option( "d", "debug build no optimization, etc..." , 0 , True , "debugBuild" )
add_option( "dd", "debug build no optimization, additional debug logging, etc..." , 0 , True , "debugBuildAndLogging" )

# new style debug and optimize flags
add_option( "dbg", "Enable runtime debugging checks", 1, True, "dbg",
            type="choice", choices=["on", "off"] )

add_option( "opt", "Enable compile-time optimization", 1, True, "opt",
            type="choice", choices=["on", "off"] )

sanitizer_choices = ["address", "memory", "thread", "undefined"]
add_option( "sanitize", "enable selected sanitizer", 1, True,
            type="choice", choices=sanitizer_choices, default=None )

add_option( "durableDefaultOn" , "have durable default to on" , 0 , True )
add_option( "durableDefaultOff" , "have durable default to off" , 0 , True )

add_option( "pch" , "use precompiled headers to speed up the build (experimental)" , 0 , True , "usePCH" )
add_option( "distcc" , "use distcc for distributing builds" , 0 , False )

# debugging/profiling help
if os.sys.platform.startswith("linux") and (os.uname()[-1] == 'x86_64'):
    defaultAllocator = 'tcmalloc'
elif (os.sys.platform == "darwin") and (os.uname()[-1] == 'x86_64'):
    defaultAllocator = 'tcmalloc'
else:
    defaultAllocator = 'system'
add_option( "allocator" , "allocator to use (tcmalloc or system)" , 1 , True,
            default=defaultAllocator )
add_option( "gdbserver" , "build in gdb server support" , 0 , True )
add_option( "heapcheck", "link to heap-checking malloc-lib and look for memory leaks during tests" , 0 , False )
add_option( "gcov" , "compile with flags for gcov" , 0 , True )

add_option("smokedbprefix", "prefix to dbpath et al. for smoke tests", 1 , False )
add_option("smokeauth", "run smoke tests with --auth", 0 , False )

add_option("use-sasl-client", "Support SASL authentication in the client library", 0, False)

add_option( "use-system-tcmalloc", "use system version of tcmalloc library", 0, True )

add_option( "use-system-pcre", "use system version of pcre library", 0, True )

add_option( "use-system-boost", "use system version of boost libraries", 0, True )

add_option( "use-system-snappy", "use system version of snappy library", 0, True )

add_option( "use-system-v8", "use system version of v8 library", 0, True )

add_option( "use-system-stemmer", "use system version of stemmer", 0, True )

add_option( "use-system-yaml", "use system version of yaml", 0, True )

add_option( "use-system-all" , "use all system libraries", 0 , True )

add_option( "use-cpu-profiler",
            "Link against the google-perftools profiler library",
            0, False )

add_option("mongod-concurrency-level", "Concurrency level, \"global\" or \"db\"", 1, True,
           type="choice", choices=["global", "db"])

add_option('build-fast-and-loose', "NEVER for production builds", 0, False)

add_option('disable-warnings-as-errors', "Don't add -Werror to compiler command line", 0, False)

add_option('propagate-shell-environment',
           "Pass shell environment to sub-processes (NEVER for production builds)",
           0, False)

if darwin:
    osx_version_choices = ['10.6', '10.7', '10.8', '10.9']
    add_option("osx-version-min", "minimum OS X version to support", 1, True,
               type = 'choice', default = osx_version_choices[0], choices = osx_version_choices)

elif windows:
    win_version_min_choices = {
        'xpsp3'   : ('0501', '0300'),
        'ws03sp2' : ('0502', '0200'),
        'vista'   : ('0600', '0000'),
        'ws08r2'  : ('0601', '0000'),
        'win7'    : ('0601', '0000'),
        'win8'    : ('0602', '0000'),
    }

    add_option("win-version-min", "minimum Windows version to support", 1, True,
               type = 'choice', default = None,
               choices = win_version_min_choices.keys())

add_option('cache',
           "Use an object cache rather than a per-build variant directory (experimental)",
           0, False)

add_option('cache-dir',
           "Specify the directory to use for caching objects if --cache is in use",
           1, False, default="#build/cached/.cache")

# don't run configure if user calls --help
if GetOption('help'):
    Return()

=== debian/changelog ===
juju-mongodb2.6 (2.6.10-0ubuntu1) xenial; urgency=medium

  [ Curtis C. Hovey ]
  * New upstream release (LP: #1557830).
  * Updated d/ based on 1:2.6.10-0ubuntu1 d/
  * d/control: 
    - Renamed source and binary package to juju-mongodb2.6.
    - Install to /usr/lib/juju/mongo2.6/bin/
    - Add libyaml-cpp-dev to BD's.
  * d/rules: Enable --with-system-yaml option. 
  * d/p 
    - Synced upstream patches with the mongodb 1:2.6.10-0ubuntu1
    - dropped be-port because juju 1.25 and juju-mongodb will not
      support s390x and powerpc; juju2 will support these archs.

  [ Robie Basak ]
  * Drop ignore of scons clean failure in line with mongodb 2.6.10-0ubuntu1.
  * Drop --system-v8 against mongodb 1:2.6.10-0ubuntu1 since we build without
    any JS engine.
  * d/control: build on "any" architecture. Some are known to fail but not for
    any fundamental reason that makes this package unsuitable for them.

 -- Robie Basak <robie.basak@ubuntu.com>  Mon, 04 Apr 2016 16:23:23 +0000

juju-mongodb (2.4.10-0ubuntu6) xenial; urgency=high

  * Drop architecture restrictions.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 06 Jan 2016 09:27:48 +0000

juju-mongodb (2.4.10-0ubuntu5) xenial; urgency=medium

  * Add be-port.patch from IBM's port. 

 -- Michael Hudson-Doyle <michael.hudson@canonical.com>  Tue, 08 Dec 2015 15:11:35 +1300

juju-mongodb (2.4.10-0ubuntu4) wily; urgency=medium

  * Fix FTBFS: (LP: #1483400)
    - Add 00git_boost_1.56.patch: Fix "std::swap" failure with current boost.
      (Backported from upstream git)
    - Add 00git_pymongo3.patch: Fix buildscripts/smoke.py for PyMongo 3.
      (Backported from upstream git)
    - Add no-unused-variable.patch: Don't fail to build on "unused-variable"
      warning.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 11 Aug 2015 10:57:23 +0200

juju-mongodb (2.4.10-0ubuntu3) wily; urgency=medium

  * No-change rebuild against libpcrecpp0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 08 Aug 2015 23:35:48 +0000

juju-mongodb (2.4.10-0ubuntu2) vivid; urgency=medium

  * d/p/no-unused-function.patch: Patch to avoid FTBFS with gcc-4.9 by using
    -Wno-unused-function. Patch cherry-picked from mongodb package in Vivid. 

 -- Oleg Strikov <oleg.strikov@canonical.com>  Mon, 20 Apr 2015 13:55:27 +0000

juju-mongodb (2.4.10-0ubuntu1) utopic; urgency=medium

  * New upstream release.

 -- James Page <james.page@ubuntu.com>  Wed, 30 Apr 2014 08:59:21 +0100

juju-mongodb (2.4.9-0ubuntu3) trusty; urgency=medium

  * d/p/0099-Pagesize-hacks.patch: Apply some hacks for non-4k pages.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 27 Mar 2014 00:47:53 -0600

juju-mongodb (2.4.9-0ubuntu2) trusty; urgency=medium

  * d/tests/binaries: Drop check for mongo binary.

 -- James Page <james.page@ubuntu.com>  Wed, 22 Jan 2014 16:39:13 +0000

juju-mongodb (2.4.9-0ubuntu1) trusty; urgency=medium

  * New upstream point release.
  * d/p/0003-SERVER-12064-Use-gcc-atomic-builtins-if-available.patch:
    Dropped - not really needed for this version on mongodb.
  * d/install: Don't ship mongo binary, its broken without a JS engine
    (LP: #1270098).
  * d/p/0005-disable-jstests.patch: Dropped in preference to updates to
    d/p/0001-Add-option-to-disable-javascript.patch - rebased on revised
    upstream pull request.
  * d/rules: Don't strip binaries during build so we get a ddeb.

 -- James Page <james.page@ubuntu.com>  Wed, 22 Jan 2014 14:52:36 +0000

juju-mongodb (2.4.8-0ubuntu6) trusty; urgency=medium

  * Switch back to running standard smoke test suite, minus jstests:
    - d/rules: Use smoke target for test execution.
    - d/patches/0005-disable-jstests.patch: Disable jstests suite.

 -- James Page <james.page@ubuntu.com>  Tue, 07 Jan 2014 21:51:41 +0000

juju-mongodb (2.4.8-0ubuntu5) trusty; urgency=medium

  * Enable better support for alternative architectures:
    - 0001-SERVER-12064-Atomic-operations-for-gcc-non-Intel-arc.patch
      0002-SERVER-12065-Support-ARM-and-AArch64-builds.patch
      0003-SERVER-12064-Use-gcc-atomic-builtins-if-available.patch:
      Cherry picked changes from Robie Basak to enable atomic operations
      on non-Intel architectures.
    - 0004-Support-ppc64el-builds.patch: Add support for detection of
      powerpc64 as a 64-bit platform.
    - d/control: Enable arm64 and ppc64el architectures.

 -- James Page <james.page@ubuntu.com>  Tue, 07 Jan 2014 16:47:27 +0000

juju-mongodb (2.4.8-0ubuntu4) trusty; urgency=medium

  * Disable javascript scripting support:
    - d/rules: Pass --disable-scripting, drop config options for v8 and sm,
      only run C++ based tests during smoke testing.
    - d/p/0001-Add-option-to-disable-javascript.patch: Cherry picked changes 
      from Michael Hudson to add support for disabling javascript support.

 -- James Page <james.page@ubuntu.com>  Tue, 07 Jan 2014 14:48:30 +0000

juju-mongodb (2.4.8-0ubuntu3) trusty; urgency=medium

  * d/rules: Ignore test failures when testing with spidermonkey
    scripting engine for the time being.
  * d/control: Drop dependency on adduser as its not required.

 -- James Page <james.page@ubuntu.com>  Thu, 19 Dec 2013 16:37:23 +0000

juju-mongodb (2.4.8-0ubuntu2) trusty; urgency=medium

  * d/rules: Use spidermonkey as scripting engine for architectures that
    don't currently have v8 support.
  * d/tests/binaries: Fix exit code handling to resolve autopkg test failure.
  * d/rules: Ignore errors from scons clean.

 -- James Page <james.page@ubuntu.com>  Tue, 17 Dec 2013 08:33:20 +0000

juju-mongodb (2.4.8-0ubuntu1) trusty; urgency=low

  * Create new binary only MongoDB package for use by Juju, supporting
    plans for inclusion of juju-core in Ubuntu main:
    - d/control: Add new juju-mongodb package, drop all others.
    - d/control: Use embedded v8 to avoid general inclusion in main.
    - d/control,d/p/series: Drop use of system libstemmer in preference
      to embedded version.


=== debian/control ===
Source: juju-mongodb2.6
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends:
 debhelper (>= 9),
 libboost-date-time-dev,
 libboost-dev (>> 1.50),
 libboost-filesystem-dev,
 libboost-program-options-dev,
 libboost-thread-dev,
 libgoogle-perftools-dev [linux-amd64],
 libpcap-dev,
 libpcre3-dev,
 libreadline-dev,
 libsnappy-dev,
 libssl-dev,
 libyaml-cpp-dev,
 python-pymongo,
 scons
Standards-Version: 3.9.5
Homepage: http://www.mongodb.org
XS-Testsuite: autopkgtest

Package: juju-mongodb2.6
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: MongoDB object/document-oriented database for Juju
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package provides the mongod and mongos binaries for use within Juju,
 the service orchestration for Ubuntu.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_SCONS_OPTIONS :=
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif
ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
       PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += -j$(PROCS)
endif

HARDENING_OPTIONS = CC="$(CC)" CFLAGS="$(CFLAGS)" \
  CXX="$(CXX)" CXXFLAGS="$(CXXFLAGS)"
COMMON_OPTIONS = --use-system-snappy --use-system-pcre \
  --use-system-boost --use-system-yaml \
  --ssl --nostrip $(DEB_SCONS_OPTIONS)

gperftools_archs = amd64
ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
COMMON_OPTIONS += --allocator=tcmalloc --use-system-tcmalloc
else
COMMON_OPTIONS += --allocator=system
endif

export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# NOTE: disable javascript scripting support
COMMON_OPTIONS += --disable-scripting

DEB_SCONS_CLEAN = --directory="." $(HARDENING_OPTIONS) . --keep-going --clean \
  $(COMMON_OPTIONS)
DEB_SCONS_BUILD = --directory="." $(HARDENING_OPTIONS) all $(COMMON_OPTIONS)
DEB_SCONS_CHECK = --smokedbprefix=$(CURDIR)/debian/tmp-test smoke \
  $(COMMON_OPTIONS)
DEB_SCONS_INSTALL = --directory="." $(HARDENING_OPTIONS) \
  --prefix=$(CURDIR)/debian/tmp/usr install --full $(COMMON_OPTIONS)

override_dh_clean:
	scons $(DEB_SCONS_CLEAN)
	find $(CURDIR)/ -name "*.pyc" -delete
	rm -rf $(CURDIR)/debian/tmp-test/
	rm -rf $(CURDIR)/.scons/
	rm -rf $(CURDIR)/build/
	rm -f $(CURDIR)/failfile.smoke $(CURDIR)/smoke-last.json
	dh_clean

override_dh_auto_build:
	scons $(DEB_SCONS_BUILD)

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	scons $(DEB_SCONS_CHECK)
endif

override_dh_auto_install:
	scons $(DEB_SCONS_INSTALL)

%:
	dh $@ --parallel

.PHONY: override_dh_clean override_dh_auto_build override_dh_auto_test \
	override_dh_auto_install

=== debian/tests/control ===
Tests: binaries
Depends: juju-mongodb2.6
